----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:14:35 08/04/2011 
-- Design Name: 
-- Module Name:    SPI_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity SPI_if is
    Port ( SCK : in  STD_LOGIC;
           CSn : in  STD_LOGIC;
           MOSI : in  STD_LOGIC;
           MISO : out  STD_LOGIC;
           SPI_we : out  STD_LOGIC;
           SPI_rdata : in  STD_LOGIC_VECTOR (7 downto 0);
           SPI_wdata : out  STD_LOGIC_VECTOR (7 downto 0);
           SPI_addr : out  STD_LOGIC_VECTOR (7 downto 0));
end SPI_if;

architecture Behavioral of SPI_if is
signal SPI_write : std_logic := '0';
signal SPI_read : std_logic := '0';
signal BitCntr : std_logic_vector(4 downto 0) := (others => '0');
signal sr_in : std_logic_vector(6 downto 0) := (others => '0');
signal sr_out : std_logic_vector(7 downto 0) := (others => '0');
signal addr : std_logic_vector(7 downto 0) := (others => '0');
signal SPI_we_i : std_logic := '0';
signal SPI_we_q : std_logic := '0';
begin
SPI_addr <= addr;
SPI_we <= SPI_we_i;
SPI_wdata <= sr_in & MOSI;
MISO <= sr_out(7);
process(SCK, CSn)
begin
	if(CSn = '1')then
		SPI_write <= '0';
		SPI_read <= '0';
		SPI_we_i <= '0';
		SPI_we_q <= '0';
		BitCntr <= (others => '0');
	elsif(SCK'event and SCK = '1')then
		BitCntr(3 downto 0) <= BitCntr(3 downto 0) + 1;
		if(BitCntr(3 downto 0) = "1111")then
			BitCntr(4) <= '1';
		end if;
		if(BitCntr = "00111" and sr_in = "0000001")then
			SPI_write <= not MOSI;
			SPI_read <= MOSI;
--			SPI_write <= MOSI;
--			SPI_read <= not MOSI;
		end if;
	  if(BitCntr(2 downto 0) = "110" and SPI_write = '1')then
			SPI_we_i <= BitCntr(4);
		else
			SPI_we_i <= '0';
		end if;
		SPI_we_q <= SPI_we_i;
	end if;
end process;
process(SCK)
begin
	if(SCK'event and SCK = '1')then
		sr_in <= sr_in(5 downto 0) & MOSI;
--	  if(BitCntr(2 downto 0) = "111")then
--			SPI_wdata <= sr_in & MOSI;
--		end if;
	  if(BitCntr = "01111")then
			addr <= sr_in & MOSI;
		elsif((SPI_read = '1' and BitCntr(2 downto 0) = "111") or SPI_we_q = '1')then
			addr <= addr + 1;
		end if;
	end if;
end process;
process(SCK)
begin
	if(SCK'event and SCK = '0')then
	  if(SPI_read = '0' or BitCntr(4) = '0')then
			sr_out <= x"ff";
	  elsif(BitCntr(2 downto 0) = "000")then
			sr_out <= SPI_rdata;
		else
			sr_out <= sr_out(6 downto 0) & '0';
		end if;
	end if;
end process;

end Behavioral;

